﻿import flash.display.BitmapData
import flash.geom.*

function initialize(){
	trace("** INIT **");
	//create an array that will be the fading image cue
	list=new Array()
	//create an identity matrix
	m=new Matrix()
	//scale the transformation matrix to match the scale of the Video object on stage
	m.scale((output._xscale/100),(output._yscale/100))
	//create a bitmap object in memory that is the same size as the Video object on stage
	now=new BitmapData(output._width,output._height)
	//create a bitmap object in memory to hold a layered bitmap from the fading image cue
	out=new BitmapData(output._width,output._height)
	//create a movieclip that can display the final bitmap
	this.createEmptyMovieClip("output_mc",this.getNextHighestDepth())
	//attach the bitmap inside the holder movie clip
	output_mc.attachBitmap(out,1)
	//position it to the right of the live Webcam feed
	output_mc._x=output._width + 250;
	output_mc._y=output._y;
	//call the snap function every 1/10th of a second
	if(_root.camInt!=undefined)clearInterval(_root.camInt);
	_root.camInt = setInterval(this,"snap",100);
}
function configColor(){
	trace("configColor")
	var n = 20;
	var col=0;
	var row=0;
	for(var i=0;i<20;i++){
		clrConfigAry[i] = new Array();
		for(var j=0;j<20;j++){
			var py = 70+i;
			var px =  50+j;
			var pxVal = now.getPixel(px,py)
			clrConfigAry[i][j] = pxVal;
		}
	}
	trace(clrConfigAry.join("*\n"));
	//
	var avgClr = computeAverageColor();
	drawClr(avgClr);
	//
	//averageColor = "0x"+avgClr.toString(16).toUpperCase();
	averageColor = avgClr;
}
function computeAverageColor():Number{
	var totalR:Number = 0;
	var totalG:Number = 0;
	var totalB:Number = 0;
	var count:Number = 0;
	//
	for (var j:Number = 0; j<20; j++) {
		for (var i:Number = 0;  i<20; i++) {
			//var col:Number = bm.getPixel(i, j);
			var col = clrConfigAry[i][j];
			if(col!=0){
				var red:Number = (col & 0xFF0000) >>> 16;
				var green:Number = (col & 0x00FF00) >>> 8;
				var blue:Number = col & 0x0000FF;
				totalR += red;
				totalG += green;
				totalB += blue;
				count++;
			}
		}
	}
	
	var targetR:Number = Math.round(totalR/count);
	var targetG:Number = Math.round(totalG/count);
	var targetB:Number = Math.round(totalB/count);
	
	//combine the color and return target color value
	var targetCol:Number = targetR << 16 | targetG << 8 | targetB;
	return  targetCol;
}
function drawClr(clrVal:String){
	this.createEmptyMovieClip("swatch_mc", 1);
	//
	var hexColor:String = "0x"+clrVal.toString(16).toUpperCase();
	trace('hexColor: ' + hexColor);
	swatch_mc.beginFill(hexColor, 100);
	swatch_mc.lineStyle(1, 0x000000, 100);
	swatch_mc.moveTo(0, 130);
	swatch_mc.lineTo(50, 130);
	swatch_mc.lineTo(50, 180);
	swatch_mc.lineTo(0, 180);
	swatch_mc.lineTo(0, 130);
	swatch_mc.endFill();
}
function trackColor(){
	// search the image
	var fnd=false;
	for (var j:Number = 0; j<160; j++) {
		for (var i:Number = 0;  i<120; i++) {
			//var col:Number = bm.getPixel(i, j);
			var px=now.getPixel(j,i);
			//var pxClr = "0x"+px.toString(16).toUpperCase();
			//trace(averageColor + " ?? " + pxClr)
			//trace(averageColor + " ?? " + px);
			//
			var red:Number = (px & 0xFF0000) >>> 16;
			trace('red: ' + red)
			var green:Number = (px & 0x00FF00) >>> 8;
			trace('green: ' + green)
			var blue:Number = px & 0x0000FF;
			trace('blue: ' + blue)
			//
			trace("---")
			var red1:Number = (averageColor & 0xFF0000) >>> 16;
			trace('r1: ' + red1)
			var green1:Number = (averageColor & 0x00FF00) >>> 8;
			trace('g1: ' + green1)
			var blue1:Number = averageColor & 0x0000FF;
			trace('b1: ' + blue1);
			//
			var v1 = Math.abs(red1-red);
			var v2 = Math.abs(green1-green);
			var v3 = Math.abs(blue1-blue);
			//trace("total diff:" + total)
			trace("")
			if(v1<20 && v2<20 && v3<20) {
				trace("---> FOUND IT");
				var pt = _root.attachMovie("blt", "blt", _root.getNextHighestDepth());
				pt._x = j;
				pt._y = i;
				fnd=true;
				return;
			}
		}
		if(fnd) return;
	}
	
}
//capture a freezeframe from the webcam and copy it, called regularly do detect movement
function snap(){
	//draw the movieclip into the bitmapdata object object with the scaled transformation matrix
	now.draw(output,m)
	//copy the current freezeframe
	done=now.clone()
	//now draw the previous freezeframe ("BEFORE"!) on top of the current frameframe and apply the 'difference' blendmode
	done.draw(before,m,null,"difference")
	//filter out all pixels in the differenced bitmap that are greater than just over black (0xFF111111) and make them green (0xFF00FF00)
	//over-write the previous contents of the bitmap
	var pxChanged = done.threshold(done,done.rectangle,done.rectangle.topLeft,">",0xFF111111,0xFF00FF00,0x00FFFFFF,false)
	// trace('pxChanged: ' + pxChanged)
	if(pxChanged > 5000) trackColor();
	//add the finished bitmap to a fading image cue
	list.push(done.clone());
	//if the cue is now greater than the maximum length we specified
	if(list.length > max){
		//then remove the bitmap at the very front of the cue
		//and free the memory it was using
		list.shift().dispose();
	}
	//how many items in the fading cue
	var l=list.length
	//how much should the green channel deteriate on each degradation
	var each=255/l;
	//declare local var to speed up the loop
	var g;
	//clear the out bitmap object so we can start a fresh
	out.fillRect(out.rectangle,0xFF000000)
	//copy the current bitmap and save it for the next time this function is called
	before=now.clone()
	//loop through each bitmap in the fading image cue
	for(var i=0;i<l;++i){
		//determine the current degradation
		g=each*i;
		//copy all the pixels that are green in the current item in the fading image cue and make them into the degradated green color
		//add those pixels on top of the bitmap that will displayed to the user
		out.threshold(list[i],out.rectangle,out.rectangle.topLeft,"==",0xFF00FF00,(255<<24 | 0<<16 | g<<8 | 0),0x00FFFFFF,false)
	}
}
//
//maximum length of the fading image cue
max=7
//check for auto allow
var autoinit=false;
//check for manual init
var maninit=false;
//get the default camera
//change your Default camera using the Flash Player Settings.
cam=Camera.get()
trace('cam: ' + cam)
//this event is called whenever permission to access the local camera, is accepted or denied by the user
cam.onStatus=function(e){
	trace("camera.onStatus");
	//if we are given permission
	if(e.code == "Camera.Unmuted"){
		//start the application
		maninit=true;
		initialize()
	}else{
		System.showSettings(3);
	}
}
cam.onActivity=function(){
	trace("camera.onActivity");
	if(autoinit==false && maninit==false){
		autoinit=true;
		initialize();
	}
	//
	trackColor();
}
//if there are no Cameras
if(cam == null){
	System.showSettings(3)
}else{
	output.attachVideo(cam)
}
//
var clrConfigAry = new Array();
var averageColor;
